## rhonabwy 0.9.12

=== CMakeLists.txt ===
#
# Rhonabwy library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(rhonabwy C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

# library info

set(PROJECT_DESCRIPTION "Create, modify, parse or export Json Web Keys as defined in the RFC 7517")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/rhonabwy/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/rhonabwy/issues")
set(LIBRARY_VERSION_MAJOR "0")
set(LIBRARY_VERSION_MINOR "9")
set(LIBRARY_VERSION_PATCH "12")
set(ORCANIA_VERSION_REQUIRED "2.1.1")
set(YDER_VERSION_REQUIRED "1.4.11")
set(ULFIUS_VERSION_REQUIRED "2.6.8")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
		set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
		set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
		set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
		set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
		set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
		set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
		check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

		if (NOT _GNU_SOURCE)
				unset(_GNU_SOURCE CACHE)
				check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
		endif ()
endif ()

if (_GNU_SOURCE)
		add_definitions(-D_GNU_SOURCE)
endif ()

include(FindJansson)
set(JANSSON_MIN_VERSION 2.4)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
if (JANSSON_FOUND)
	set(LIBS ${LIBS} ${JANSSON_LIBRARIES})
	include_directories(${JANSSON_INCLUDE_DIRS})
endif ()

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
if (GNUTLS_FOUND)
	set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
	include_directories(${GNUTLS_INCLUDE_DIRS})
endif ()

include(FindZLIB)
find_package(ZLIB REQUIRED)
if (ZLIB_FOUND)
	set(LIBS ${LIBS} ${ZLIB_LIBRARIES})
	include_directories(${ZLIB_INCLUDE_DIRS})
endif ()

include(FindMHD)
find_package(MHD REQUIRED)

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(RNBYC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tools/rnbyc)

include_directories(${INC_DIR})

set(LIB_SRC
				${INC_DIR}/rhonabwy.h # allow many IDEs to find and edit it
				${SRC_DIR}/misc.c
				${SRC_DIR}/jwk.c
				${SRC_DIR}/jwks.c
	${SRC_DIR}/jws.c
	${SRC_DIR}/jwe.c
	${SRC_DIR}/jwt.c)

set(PKGCONF_REQ "")
set(PKGCONF_REQ_PRIVATE "")

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
		add_library(rhonabwy_static STATIC ${LIB_SRC})
		target_compile_definitions(rhonabwy_static PUBLIC -DO_STATIC_LIBRARY)
		set_target_properties(rhonabwy_static PROPERTIES
						OUTPUT_NAME rhonabwy)
endif ()

# shared library

add_library(rhonabwy SHARED ${LIB_SRC})
set_target_properties(rhonabwy PROPERTIES
				COMPILE_OPTIONS -Wextra
				PUBLIC_HEADER "${INC_DIR}/rhonabwy.h;${PROJECT_BINARY_DIR}/rhonabwy-cfg.h"
				VERSION "${LIBRARY_VERSION}"
				SOVERSION "${LIBRARY_SOVERSION}")
target_link_libraries(rhonabwy ${LIBS})

set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during yder search and download
set(SEARCH_ORCANIA_U OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during ulfius search and download
set(SEARCH_YDER OFF CACHE BOOL "Force to false") # Avoid to search and download yder during ulfius and hoel search and download

option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)

option(SEARCH_ORCANIA_R "Search for ORCANIA library" ON)
if (SEARCH_ORCANIA_R)
		set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
		include(FindOrcania)
		find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
		if (NOT ORCANIA_FOUND)
      if (DOWNLOAD_DEPENDENCIES)
          include(DownloadProject)
          message(STATUS "Download Orcania ${ORCANIA_VERSION_REQUIRED}")
          download_project(PROJ orcania # ... otherwise, download archive
              URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
              QUIET)
          add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
          include_directories(${orcania_SOURCE_DIR}/include)
          add_dependencies(rhonabwy orcania)
          set(ORCANIA_LIBRARIES orcania)
          include_directories(${orcania_BINARY_DIR})
				else ()
						message( FATAL_ERROR "Orcania not found")
				endif ()
		endif ()
		target_link_libraries(rhonabwy ${LIBS} ${ORCANIA_LIBRARIES})
		set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
endif ()

option(SEARCH_YDER_R "Search for YDER library" ON)
if (SEARCH_YDER_R)
		set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
		include(FindYder)
		find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
		if (NOT YDER_FOUND)
      if (DOWNLOAD_DEPENDENCIES)
          include(DownloadProject)
          message(STATUS "Download Yder ${YDER_VERSION_REQUIRED}")
          option(CHECK_ORCANIA "specific param" off)
          download_project(PROJ yder # ... otherwise, download archive
              URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
              QUIET)
          add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
          include_directories(${yder_SOURCE_DIR}/include)
          include_directories(${orcania_SOURCE_DIR}/include)
          add_dependencies(rhonabwy yder)
          set(YDER_LIBRARIES yder)
          include_directories(${yder_BINARY_DIR})
				else ()
						message( FATAL_ERROR "Yder not found")
				endif ()
		endif ()
		target_link_libraries(rhonabwy ${LIBS} ${YDER_LIBRARIES})
		set(LIBS ${LIBS} ${YDER_LIBRARIES})
endif ()

option(SEARCH_ULFIUS_R "Search for ULFIUS library" ON)
if (SEARCH_ULFIUS_R)
		set(Ulfius_FIND_QUIETLY ON)
		include(FindUlfius)
		find_package(Ulfius ${ULFIUS_VERSION_REQUIRED} QUIET)
		if (NOT ULFIUS_FOUND)
      if (DOWNLOAD_DEPENDENCIES)
          include(DownloadProject)
          option(CHECK_ORCANIA "specific param" off)
          option(CHECK_YDER "specific param" off)
          message(STATUS "Download Ulfius ${ULFIUS_VERSION_REQUIRED}")
          download_project(PROJ ulfius
              URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
              QUIET)
          add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
          include_directories(${yder_SOURCE_DIR}/include)
          include_directories(${orcania_SOURCE_DIR}/include)
          include_directories(${ulfius_SOURCE_DIR}/include)
          add_dependencies(rhonabwy ulfius)
          set(ULFIUS_LIBRARIES ulfius)
          include_directories(${ulfius_BINARY_DIR})
				else ()
						message( FATAL_ERROR "Ulfius not found")
				endif ()
		endif ()
		target_link_libraries(rhonabwy ${LIBS} ${ULFIUS_LIBRARIES})
		set(LIBS ${LIBS} ${ULFIUS_LIBRARIES})
endif ()

# build rnbyc

option(BUILD_RNBYC "Build rnbyc application." ON)

if (BUILD_RNBYC)
		add_executable(rnbyc ${RNBYC_DIR}/rnbyc.c ${INC_DIR}/rhonabwy.h ${PROJECT_BINARY_DIR}/rhonabwy-cfg.h)
		set_target_properties(rnbyc PROPERTIES SKIP_BUILD_RPATH TRUE)
		add_dependencies(rnbyc rhonabwy)
		target_link_libraries(rnbyc rhonabwy orcania yder ulfius ${LIBS})
		install(TARGETS rnbyc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
		INSTALL(FILES ${RNBYC_DIR}/rnbyc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
endif ()

# documentation

option(BUILD_RHONABWY_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_RHONABWY_DOCUMENTATION)
		find_package(Doxygen)
		if (DOXYGEN_FOUND)
				set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
				set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
				
				configure_file(${doxyfile_in} ${doxyfile} @ONLY)
				
				add_custom_target(doc
													COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
													WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
													COMMENT "Generating documentation with Doxygen"
													VERBATIM)

		else ()
				message(FATAL_ERROR "Doxygen is needed to build the documentation.")
		endif ()
endif ()

# build rhonabwy-cfg.h file
configure_file(${INC_DIR}/rhonabwy-cfg.h.in ${PROJECT_BINARY_DIR}/rhonabwy-cfg.h)
set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR})

# tests

option(BUILD_RHONABWY_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)

if (BUILD_RHONABWY_TESTING)
		include(FindCheck)
		find_package(Check REQUIRED)
		if (CHECK_FOUND)
		include(FindSubunit)
		find_package(Subunit REQUIRED)
				find_package(Threads REQUIRED)

				enable_testing()

				set(CMAKE_CTEST_COMMAND ctest -V)

				set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
				set(LIBS rhonabwy ${LIBS} ${CHECK_LIBRARIES} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} "-lm -lrt")

				set(TESTS
						misc
			jwk_core
						jwk_export
			jwk_import
			jwks_core
			jws_core
			jws_hmac
			jws_ecdsa
			jws_rsa
			jws_rsapss
			jwe_core
			jwe_rsa
			jwe_aesgcm
			jwe_dir
			jwt_core
			jwt_encrypt
			jwt_sign
			jwt_nested
			)

				configure_file(
								"${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
								"${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
								@ONLY)

				foreach (t ${TESTS})
						add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
						target_include_directories(${t} PUBLIC ${TST_DIR})
						target_link_libraries(${t} PUBLIC ${LIBS})
						add_test(NAME ${t}
										WORKING_DIRECTORY ${TST_DIR}
										COMMAND ${t})
				endforeach ()
		endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install rhonabwy.h or not

configure_file(librhonabwy.pc.in librhonabwy.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/librhonabwy.pc
				DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

set(TARGETS rhonabwy)

if (INSTALL_HEADER)
		install(TARGETS ${TARGETS}
						RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
						LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
						ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
						PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
else ()
		install(TARGETS ${TARGETS}
						RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
						LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
						ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

# uninstall target

if (NOT TARGET uninstall)
		configure_file(
						"${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
						"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
						IMMEDIATE @ONLY)
		add_custom_target(uninstall
						COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})

=== src/Makefile ===
#
# Rhonabwy Library
#
# Makefile used to build the software
#
# Copyright 2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PROJECT_NAME=rhonabwy
PROJECT_DESCRIPTION=OAuth2 client library
PROJECT_BUGREPORT_PATH=https://github.com/babelouest/rhonabwy/issues
PKGCONF_REQ=
PKGCONF_REQ_PRIVATE=
RHONABWY_INCLUDE=../include
PKGCONFIG_FILE=../librhonabwy.pc
PKGCONFIG_TEMPLATE=../librhonabwy.pc.in
DESTDIR=/usr/local
CONFIG_FILE=$(RHONABWY_INCLUDE)/rhonabwy-cfg.h
CONFIG_TEMPLATE=$(RHONABWY_INCLUDE)/rhonabwy-cfg.h.in
CC=gcc
CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -D_REENTRANT -I$(RHONABWY_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-L$(DESTDIR)/lib -lc -lorcania -lyder -lulfius -ljansson -lgnutls $(LDFLAGS)
SONAME=-soname
OBJECTS=jwk.o jwks.o jws.o jwe.o jwt.o misc.o
OUTPUT=librhonabwy.so
VERSION_MAJOR=0
VERSION_MINOR=9
VERSION_PATCH=12

.PHONY: all clean

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)        

$(PKGCONFIG_FILE):
	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@CMAKE_INSTALL_LIBDIR@/lib/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@CMAKE_INSTALL_INCLUDEDIR@/include/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)

target: $(OBJECTS)

%.o: %.c $(RHONABWY_INCLUDE)/rhonabwy.h
	$(CC) $(CFLAGS) $<

librhonabwy.so: $(CONFIG_FILE) $(OBJECTS)
	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LYDER) $(LJANSSON) $(LGNUTLS)
	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(PKGCONFIG_FILE) $(CONFIG_FILE)

install: all $(PKGCONFIG_FILE)
	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
	install -m644 $(RHONABWY_INCLUDE)/rhonabwy.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	-ldconfig $(DESTDIR)/lib

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/librhonabwy.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/rhonabwy.h
	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: librhonabwy.so

release: ADDITIONALFLAGS=-O3

release: librhonabwy.so

=== debian/changelog ===
rhonabwy (0.9.12-2build1) groovy; urgency=medium

  * No change rebuild against new GnuTLS 3.6.14 A192GCM support ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 28 Sep 2020 14:47:14 +0100

rhonabwy (0.9.12-2) unstable; urgency=medium

  * d/patches: Disable test_rhonabwy_generate_key_pair, takes too much time
    in some environments

 -- Nicolas Mora <babelouest@debian.org>  Mon, 13 Jul 2020 12:00:37 -0400

rhonabwy (0.9.12-1) unstable; urgency=medium

  * New upstream release
  * d/uwsc.1: Remove uwsc manpage, use upstream manpage instead

 -- Nicolas Mora <babelouest@debian.org>  Mon, 13 Jul 2020 07:31:35 -0400

rhonabwy (0.9.11-3) unstable; urgency=medium

  * d/rules: avoid downloading dependencies if not found
  * rename rnbyc manpage to rnbyc.1

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 02 Jul 2020 20:56:30 -0400

rhonabwy (0.9.11-2) unstable; urgency=medium

  * Upload to unstable
  * Set upstream metadata fields
  * d/patches/test_timeout.patch: increase core timeout because it fails
    on some architectures

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 28 Jun 2020 12:42:51 -0400

rhonabwy (0.9.11-1) experimental; urgency=medium

  * New upstream release
  * d/control: Add rnbyc

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 23 Jun 2020 15:42:34 -0400

rhonabwy (0.9.10-1) experimental; urgency=medium

  * New upstream version

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 04 Jun 2020 12:14:12 -0400

rhonabwy (0.9.9-1) experimental; urgency=medium

  * Initial release (Closes: #961720)

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 25 May 2020 21:18:21 -0400

=== debian/control ===
Source: rhonabwy
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , dh-exec
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , libgnutls28-dev
             , zlib1g-dev
             , cmake
             , pkg-config
             , check
             , doxygen
Standards-Version: 4.5.0
Homepage: https://github.com/babelouest/rhonabwy
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/rhonabwy
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/rhonabwy.git
Rules-Requires-Root: no

Package: librhonabwy0.9
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JWK, JWKS, JWS, JWE and JWT library
 Rhonabwy - JWK, JWKS, JWS, JWE and JWT library
 .
  - Create, modify, parse, import or export JSON Web Keys (JWK) and JSON Web
    Keys Set (JWKS)
  - Create, modify, parse, validate or serialize JSON Web Signatures (JWS)
  - Create, modify, parse, validate or serialize JSON Web Encryption (JWE)
    limited and experimental!
  - Create, modify, parse, validate or serialize JSON Web Token (JWT)
 .
 JWT Relies on JWS and JWE functions, so it supports the same functionnalities
 as the other 2. JWT functionnalities also support nesting serilization
 (JWE nested in a JWS or the opposite).

Package: librhonabwy-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: librhonabwy0.9 (= ${binary:Version}), ${misc:Depends}
Description: JWK, JWKS, JWS, JWE and JWT library - development
 Rhonabwy - JWK, JWKS, JWS, JWE and JWT library
 .
  - Create, modify, parse, import or export JSON Web Keys (JWK) and JSON Web
    Keys Set (JWKS)
  - Create, modify, parse, validate or serialize JSON Web Signatures (JWS)
  - Create, modify, parse, validate or serialize JSON Web Encryption (JWE)
    limited and experimental!
  - Create, modify, parse, validate or serialize JSON Web Token (JWT)
 .
 JWT Relies on JWS and JWE functions, so it supports the same functionnalities
 as the other 2. JWT functionnalities also support nesting serilization
 (JWE nested in a JWS or the opposite).
 .
 This package contains the development files.

Package: rnbyc
Architecture: any
Depends: ${shlibs:Depends},
       , librhonabwy0.9 (= ${binary:Version})
       , ${misc:Depends}
Description: JWK and JWT parser and generator
 Rhonabwy JWK and JWT parser and generator
 .
  - Generate and/or parse keys and output the result in a JWKS or a
    public/private pair of JWKS files.
  - Parse, decrypt, and/or verify signature of a JWT, using given key
  - Serialize a JWT, the JWT can be signed, encrypted or nested

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@  --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) \
	                    -DSKIP_BUILD_RPATH=TRUE \
	                    -DBUILD_RHONABWY_TESTING=ON \
	                    -DINSTALL_HEADER=ON \
	                    -DDOWNLOAD_DEPENDENCIES=OFF \
	                    --no-warn-unused-cli

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	dh_auto_test
endif

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	dh_auto_build --

=== debian/tests/control ===
Tests: unit-test
Depends: @, libgnutls28-dev, zlib1g-dev, libulfius-dev, gcc, libc-dev, liborcania-dev, libyder-dev, check, libsubunit-dev, pkg-config

## rhonabwy 0.9.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,10 +30,10 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/rhonabwy/issues")
 set(LIBRARY_VERSION_MAJOR "0")
 set(LIBRARY_VERSION_MINOR "9")
-set(LIBRARY_VERSION_PATCH "12")
+set(LIBRARY_VERSION_PATCH "13")
 set(ORCANIA_VERSION_REQUIRED "2.1.1")
-set(YDER_VERSION_REQUIRED "1.4.11")
-set(ULFIUS_VERSION_REQUIRED "2.6.8")
+set(YDER_VERSION_REQUIRED "1.4.12")
+set(ULFIUS_VERSION_REQUIRED "2.7.0")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})

=== Makefile ===
#
# Iddawc library
#
# Makefile used to build all programs
#
# Copyright 2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

LIBIDDAWC_LOCATION=./src
TESTS_LOCATION=./test
RNBYC_LOCATION=./tools/rnbyc

all:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) $*
	cd $(RNBYC_LOCATION) && $(MAKE) $*

debug:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) debug $*
	cd $(RNBYC_LOCATION) && $(MAKE) debug $*

clean:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) clean
	cd $(TESTS_LOCATION) && $(MAKE) clean
	cd $(RNBYC_LOCATION) && $(MAKE) clean

install:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) install
	cd $(RNBYC_LOCATION) && $(MAKE) install

uninstall:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) uninstall
	cd $(RNBYC_LOCATION) && $(MAKE) uninstall

check:
	cd $(TESTS_LOCATION) && $(MAKE)

doxygen:
	doxygen doc/doxygen.cfg

=== src/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 OUTPUT=librhonabwy.so
 VERSION_MAJOR=0
 VERSION_MINOR=9
-VERSION_PATCH=12
+VERSION_PATCH=13
 
 .PHONY: all clean

=== test/Makefile ===
#
# Iddawc library
#
# Makefile used to build the tests
#
# Public domain, no copyright. Use at your own risk.
#

RHONABWY_INCLUDE=../include
RHONABWY_LOCATION=../src
RHONABWY_LIBRARY=$(RHONABWY_LOCATION)/librhonabwy.so
CC=gcc
CFLAGS+=-Wall -D_REENTRANT -I$(RHONABWY_INCLUDE) -DDEBUG -g -O0 $(CPPFLAGS)
LDFLAGS=-lc -lorcania -lyder -ljansson -lgnutls -lrhonabwy -L$(RHONABWY_LOCATION) $(shell pkg-config --libs check) -lulfius
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all
TARGET=jwk_core jwk_import jwk_export jwks_core jws_core jws_hmac jws_rsa jws_ecdsa jws_rsapss jwe_core jwe_rsa jwe_dir jwe_aesgcm jwt_core jwt_sign jwt_encrypt jwt_nested misc
MEMCHECK=0

all: test

clean:
	rm -f *.o $(TARGET) valgrind-*.txt

$(RHONABWY_LIBRARY): $(RHONABWY_LOCATION)/misc.c $(RHONABWY_LOCATION)/jwk.c $(RHONABWY_LOCATION)/jwks.c $(RHONABWY_LOCATION)/jws.c $(RHONABWY_LOCATION)/jwe.c $(RHONABWY_LOCATION)/jwt.c $(RHONABWY_INCLUDE)/rhonabwy.h
	cd $(RHONABWY_LOCATION) && $(MAKE) debug

%: %.c
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

test_%: % $(RHONABWY_LIBRARY)
	@if [ "$(MEMCHECK)" = "0" ]; then \
	  LD_LIBRARY_PATH=$(RHONABWY_LOCATION):$(LD_LIBRARY_PATH) ./$^ ; \
	else \
	  CK_FORK=no LD_LIBRARY_PATH=$(RHONABWY_LOCATION):$(LD_LIBRARY_PATH) $(VALGRIND_COMMAND) ./$^ 2>valgrind-$@.txt; \
	fi

test-jwk: test_jwk_core test_jwk_import test_jwk_export test_jwks_core test_jws_core

test-jws: test_jws_core test_jws_hmac test_jws_rsa test_jws_ecdsa test_jws_rsapss

test-jwe: test_jwe_core test_jwe_rsa test_jwe_dir test_jwe_aesgcm

test-jwt: test_jwt_core test_jwt_sign test_jwt_encrypt test_jwt_nested

test: $(TARGET) test_misc test-jwk test-jws test-jwe test-jwt

check: test

test: $(TARGET)

=== tools/rnbyc/Makefile ===
#
# rnbyc: Rhonabwy command-line tool
#
# Makefile used to build the software
#
# Copyright 2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc
RHONABWY_INCLUDE=../../include
RHONABWY_LOCATION=../../src
DESTDIR=/usr/local

CFLAGS+=-Wall -I$(RHONABWY_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-lc -lrhonabwy -lorcania -lyder -ljansson -lgnutls -L$(RHONABWY_LOCATION)
RHONABWY_LIBRARY=../../src/librhonabwy.so
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all --track-origins=yes
CLAIMS='{"plop":"grut"}'

all: rnbyc

all: ADDITIONALFLAGS= -O3

clean:
	rm -f *.o rnbyc valgrind-??.txt priv.jwks pub.jwks token?.jwt

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: rnbyc

$(RHONABWY_LIBRARY):
	cd $(RHONABWY_LOCATION) && $(MAKE) debug

rnbyc: $(RHONABWY_LIBRARY) rnbyc.c
	$(CC) -o rnbyc $(CFLAGS) rnbyc.c $(LIBS)

install: rnbyc
	mkdir -p $(DESTDIR)/bin $(DESTDIR)/man/man1/
	install -m755 rnbyc $(DESTDIR)/bin
	install -m644 rnbyc.1 $(DESTDIR)/man/man1/

uninstall:
	rm -f $(DESTDIR)/bin/rnbyc

manpage: rnbyc
	help2man ./rnbyc -s 1 -n "JWK and JWT parser and generator" > rnbyc.1

test: test-jwks test-serialize test-parse

test-jwks: debug
	# JWKS
	$(VALGRIND_COMMAND) ./rnbyc -h 2>valgrind-01.txt
	$(VALGRIND_COMMAND) ./rnbyc -v 2>valgrind-02.txt
	$(VALGRIND_COMMAND) ./rnbyc --error 2>valgrind-03.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -j -g RSA2048 -o priv.jwks -p pub.jwks 2>valgrind-04.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -f priv.jwks -f pub.jwks 2>valgrind-05.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g oct256 -k "oct-1" 2>valgrind-06.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g ECDSA256 -n 4 2>valgrind-07.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g ECDSA384 -a "plop" -e "grut" 2>valgrind-08.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g EDDSA 2>valgrind-09.txt
	$(VALGRIND_COMMAND) ./rnbyc -j -g error 2>valgrind-10.txt || true
	cat priv.jwks | $(VALGRIND_COMMAND) ./rnbyc -j -i 2>valgrind-11.txt
	
test-serialize: debug
	# Serialize JWT
	$(VALGRIND_COMMAND) ./rnbyc -s 'error' 2>valgrind-20.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) 1>token0.jwt 2>valgrind-21.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P pub.jwks 2>valgrind-22.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P pub.jwks -l RSA1_5 1>token1.jwt 2>valgrind-23.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P priv.jwks -l RSA1_5 2>valgrind-24.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K priv.jwks 2>valgrind-25.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K priv.jwks -a RS256 1>token2.jwt 2>valgrind-26.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K pub.jwks -a RS256 2>valgrind-27.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K priv.jwks -P pub.jwks -a RS256 -l RSA1_5 1>token3.jwt 2>valgrind-28.txt
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -K token0.jwt 2>valgrind-29.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -s $(CLAIMS) -P token0.jwt 2>valgrind-30.txt || true

test-parse: debug
	# Parse JWT
	$(VALGRIND_COMMAND) ./rnbyc -t "error" 2>valgrind-40.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token0.jwt) 2>valgrind-41.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) 2>valgrind-42.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) -P pub.jwks 2>valgrind-43.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) -K priv.jwks 2>valgrind-44.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token2.jwt) 2>valgrind-45.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token2.jwt) -K priv.jwks 2>valgrind-46.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token2.jwt) -P pub.jwks 2>valgrind-47.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token3.jwt) 2>valgrind-48.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token3.jwt) -K priv.jwks 2>valgrind-49.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token3.jwt) -P pub.jwks 2>valgrind-50.txt || true
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token3.jwt) -P pub.jwks -K priv.jwks 2>valgrind-51.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) -P pub.jwks -H true -C false 2>valgrind-52.txt
	$(VALGRIND_COMMAND) ./rnbyc -t $(shell cat token1.jwt) -P pub.jwks -H false -C false 2>valgrind-53.txt

=== debian/changelog ===
rhonabwy (0.9.13-4) unstable; urgency=medium

  * d/rules: remove dpkg-shlibdeps from override_dh_auto_install
  * d/patches/bugfixes: apply upstream bugfixes (Closes: #993866)

 -- Nicolas Mora <babelouest@debian.org>  Tue, 07 Sep 2021 11:42:23 -0400

rhonabwy (0.9.13-3) unstable; urgency=medium

  * Fix r_library_info_json_t output

 -- Nicolas Mora <babelouest@debian.org>  Tue, 09 Feb 2021 07:33:21 -0500

rhonabwy (0.9.13-2) unstable; urgency=medium

  * d/control: Add jansson in builddep and librhonabwy-dev dep

 -- Nicolas Mora <babelouest@debian.org>  Wed, 06 Jan 2021 07:35:56 -0500

rhonabwy (0.9.13-1) unstable; urgency=medium

  * New upstream release
  * d/control: Remove dh-exec from builddep
  * d/rules: update override_dh_auto_test to generate certificates
  * d/control: Add builddep gnutls-bin to generate certificates
  * d/symbols: Update symbols table
  * d/control: Update standards version to 4.5.1 (no change)
  * d/tests: add gnutls-bin to generate certificates for tests
  * d/control: add librhonabwy-dev dependendies

 -- Nicolas Mora <babelouest@debian.org>  Wed, 16 Dec 2020 08:49:38 -0500

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
+	cd test && ./cert/create-cert.sh && cp -R cert/ ../build/
 	dh_auto_test
 endif
